(**$Revision: 1.83 $**)
PROGRAM GSV;
USES
    os2def,os2base,os2pmapi,
    NuCell,GSVUnit,
    uGetOpt,
    xmlcfg,
    VPUtils,Classes,SysUtils;
{$PMTYPE PM}

{$R gsv.res}

CONST
    MaxTimer=4;
    TimerAry:ARRAY[1..MaxTimer] OF INTEGER=(1000,2000,5000,10000);
CONST
    wm_EndThread =  wm_User+1;
    wm_GSVStart  =  wm_User+2;

    MainTimerID:ULong=TID_USERMAX-1;
    ClientTimerID:Ulong=TID_USERMAX-2;


    idGraphShow  =  11000;
    ID_Pane      =  11001;
    ID_DRAWPANE  =  11002;
    ID_TOOLBAR   =  11003;

    IDB_LEFT     =  12001;
    IDB_RIGHT    =  12002;
    IDB_UP       =  12003;
    IDB_DOWN     =  12004;
    IDB_FIT      =  12005;
    IDB_RUN      =  12006;
    IDB_STOP     =  12007;
    IDB_EXIT     =  12008;
    IDB_UPTIME   =  12009;
    IDB_DOWNTIME =  12010;
    IDB_FULLSCR  =  12011;
    IDB_SETTING  =  12012;

    ID_GSVSetting   =13000;
    ID_RADIO1       =13001;
    ID_RADIO2       =13002;
    ID_RADIO5       =13003;
    ID_RADIO10      =13004;
    ID_SPINTEXT     =13005;
    ID_SLIDER       =13006;
    ID_SLIDERTEXT   =13007;

(* Local procedures *)

FUNCTION MainClientProc(Window: HWnd; Msg: ULong; Mp1,Mp2: MParam): MResult;
                                                              cdecl; forward;
FUNCTION DrawPaneClientProc(Window:HWnd;Msg:ULong;Mp1,Mp2:MParam):MResult;
                                                              cdecl;forward;
FUNCTION PaneClientProc(Window:HWnd;Msg:ULong;Mp1,Mp2:MParam):MResult;
                                                              cdecl;forward;

(* Static Variables *)

CONST
    DrawPane    :CellDef =(lType:CELL_WINDOW;
                         pszClass:'BitmapPane';
                         pszName:'';
                         ulStyle:WS_VISIBLE;
                         ulID:ID_DRAWPANE;
                         pPanel1:NIL;
                         pPanel2:NIL;
                         pClassProc:NIL;
                         pClientClassProc:DrawPaneClientProc
                         );

    pane        :CellDef=(lType:CELL_HSPLIT ;
                         pszClass:NIL;
                         pszName:'pane';
                         ulStyle:WS_VISIBLE OR
                                 FCF_vertscroll OR fcf_HorzScroll;
                         ulID:ID_PANE;
                         pPanel1:@DrawPane;
                         pPanel2:NIL;
                         pClassProc:NIL;
                         pClientClassProc:PaneClientProc
                         );

    mainClient :CellDef=(lType:CELL_HSPLIT ;
                         pszClass:NIL;
                         pszName:'GSV:';
                         ulStyle:FCF_TITLEBAR OR FCF_SYSMENU OR
                                 FCF_MINMAX OR FCF_ICON OR FCF_ACCELTABLE OR
                                 FCF_TASKLIST OR FCF_SIZEBORDER ;
                         ulID:idGraphShow;
                         pPanel1:@Pane;
                         pPanel2:NIL;
                         pClassProc:NIL;          // Frame subclass proc
                         pClientClassProc:MainClientProc
                            );

      mainItems:ARRAY [0..16] OF TBItemData=(
            (NuID:IDB_LEFT      ;cText:' previous picture '),
            (NuID:IDB_RIGHT     ;cText:' next picture '),
            (NuID:TB_SEPARATOR),
            (NuID:IDB_FIT       ;cText:' Fit Window'),
            (NuID:IDB_UP        ;cText:' Scale Up'),
            (NuID:IDB_DOWN      ;cText:' Scale Down'),
            (NuID:TB_SEPARATOR),
            (NuID:IDB_RUN       ;cText:' play slide show '),
            (NuID:IDB_STOP      ;cText:' sotp slide show '),
            (NuID:TB_SEPARATOR  ;cText:''),
            (NuID:IDB_DownTime  ;cText:' Down SlideShow Time'),
            (NuID:IDB_UpTime    ;cText:' Up SlideShow Time'),
            (NuID:TB_SEPARATOR  ;cText:''),
            (NuID:IDB_SETTING   ;cText:' Setting'),
            (NuID:TB_SEPARATOR  ;cText:''),
            (NuID:IDB_EXIT      ;cText:' Exit Application '),
            (NuID:0)
      );

      mainTb:TbDef = (lType:TB_VERTICAL OR TB_ATTACHED_BT OR TB_BUBBLE ;
                      ulID:ID_TOOLBAR;
                      tbItems:@mainItems);



TYPE
    GraphScreenClass=CLASS(GraphDataClass)
        hwndPane:HWnd;
        hwndVScrol,hwndHScrol:hwnd;
        hwndMinMax,hwndTitle,hwndSysMenu:hwnd;
        OrgSWP:SWP;
        OrgFrameFlag,OrgBorder:ULong;
        ThreadID:INTEGER;
        cx,cy:INTEGER;
        xEdge,yEdge:INTEGER;
        TimerIndex:INTEGER;
        isRGBColor:BOOLEAN;
        isFullScreen:BOOLEAN;

        constructor Create;
        PROCEDURE SetPaneSize(x,y:INTEGER);
        PROCEDURE CalcFitScale;
        PROCEDURE CreateScroll(window:hwnd);
        PROCEDURE SetScroll;
        FUNCTION CalcEdge:RectL;
        PROCEDURE RedrawMsg;
        FUNCTION isArgEmpty:BOOLEAN;
        FUNCTION GetStatusStr:string;
        PROCEDURE DrawScreen(window:hwnd);
    END;

CONST
    XMLConfName:string='gsvcfg.xml';
    isColorDefine='gsv/BkColor/isDefine';
    ColorValue='gsv/BkColor/Value';
    xPosPath='gsv/window/x';
    yPosPath='gsv/window/y';
    xWidthPath='gsv/window/width';
    yHeightPath='gsv/window/height';
VAR
    cfg: TXMLConfig;
    isSubDir:BOOLEAN;
    isSort:BOOLEAN;
    isRun:BOOLEAN;
    isRGBColor:BOOLEAN;
    xWidth,yHeight,xPos,yPos:INTEGER;

    GetOpt:GetOptClass;
    GSVClass:GraphScreenClass;
    hwndFrame,hwndTB:HWND;
    BkCol:ULong;

PROCEDURE LoadCfg;
VAR
    St:string;
    aSWP:swp;
    CfgPath:string;
BEGIN
    WinQueryWindowPos(HWND_DESKTOP, aSWP);

    xPos:=(aSWP.x+aSWP.cx div 8) ;
    yPos:=(aSWP.y+aSWP.cy div 8) ;
    xWidth:=(aSWP.cx div 4) *3 ;
    yHeight:=(aSWP.cy div 4) *3;

    cfgPath:=ExtractFilePath(ParamStr(0))+XMLConfName;
    cfg:=TXMLConfig.Create(cfgPath);
    isRGBColor:=cfg.GetValueBool(isColorDefine,FALSE);
    IF isRGBColor THEN BEGIN
        St:=cfg.GetValue(ColorValue,IntToStr(CLR_WHITE));
        TRY
            BkCol:=StrToInt(St);
        EXCEPT
            BkCol:=CLR_WHITE;
            isRGBColor:=FALSE;
        END;
    END
    ELSE
        BkCol:=CLR_WHITE;
    xPos:=cfg.GetValueInteger(xPosPath,xPos);
    yPos:=cfg.GetValueInteger(yPosPath,yPos);
    xWidth:=cfg.GetValueInteger(xWidthPath,xWidth);
    yHeight:=cfg.GetValueInteger(yHeightPath,yHeight);
    cfg.Free;
END;

PROCEDURE SaveCfg;
VAR
    swap:Swp;
    cfgPath:string;
BEGIN
    cfgPath:=ExtractFilePath(ParamStr(0))+XMLConfName;
    WinQueryWindowPos(hwndFrame,swap);
    xPos:=swap.x;
    yPos:=swap.y;
    xWidth:=swap.cx;
    yHeight:=swap.cy;

    cfg:=TXMLConfig.Create(cfgPath);
    cfg.SetValueBool(isColorDefine, GSVClass.isRGBColor);
    cfg.SetValue(ColorValue, '$'+IntToHex(BkCol,8) );
    cfg.SetValueInteger(xPosPath,xPos);
    cfg.SetValueInteger(yPosPath,yPos);
    cfg.SetValueInteger(xWidthPath,xWidth);
    cfg.SetValueInteger(yHeightPath,yHeight);
    cfg.Free;
END;

constructor GraphScreenClass.Create;
BEGIN
    inherited Create;
    xEdge:=0;yEdge:=0;
    hwndPane:=NullHandle;
    TimerIndex:=1;
    isRGBColor:=FALSE;
    isFullScreen:=FALSE;
END;

PROCEDURE GraphScreenClass.SetPaneSize(x,y:INTEGER);
BEGIN
    cx:=x;
    cy:=y;
END;

PROCEDURE GraphScreenClass.CalcFitScale;
VAR
    rect:RectL;
BEGIN
    IF hwndPane=NullHandle THEN BEGIN
        rect.xLeft:=0;rect.yTop:=480;
        rect.xRight:=640;rect.yBottom:=0;
    END
    ELSE
        WinQueryWindowRect(hwndPane,rect);
    xEdge:=0;
    yEdge:=0;
    FitWindow(rect);
END;

PROCEDURE GraphScreenClass.CreateScroll(window:hwnd);
BEGIN
    HwndVScrol:=WinWindowFromID(WinQueryWindow(Window,QW_PARENT),
                                FID_VERTSCROLL);
    HwndHScrol:=WinWindowFromID(WinQueryWindow(Window, QW_PARENT),
                                FID_HORZSCROLL);
END;

PROCEDURE GraphScreenClass.SetScroll;
BEGIN
    IF pBMPBody^.sCy<=Cy THEN BEGIN
        WinEnableWindow( hwndVScrol, FALSE );
        yEdge:=0;
    END
    ELSE BEGIN
        WinEnableWindow( hwndVScrol, TRUE);
        WinSendMsg( hwndVScrol,
                    SBM_SETSCROLLBAR,
                    MPFROM2SHORT(0, 0),
                    MPFROM2SHORT(0, pBMPBody^.sCy-Cy) );
        WinSendMsg( hwndVScrol,
                    SBM_SETTHUMBSIZE,
                    MPFROM2SHORT(Cy,pBMPBody^.sCy),
                    MPFROM2SHORT(0, 0) );
        WinSendMsg( hwndVScrol,
                    SBM_SETPOS,
                    MPFROMSHORT((pBMPBody^.sCy-Cy) div 2 +yEdge),
                    0);
    END;
    IF pBMPBody^.sCx<=Cx THEN BEGIN
        WinEnableWindow( hwndHScrol, FALSE );
        xEdge:=0;
    END
    ELSE BEGIN
        WinEnableWindow( hwndHScrol, true);
        WinSendMsg( hwndHScrol,
                    SBM_SETSCROLLBAR,
                    MPFROM2SHORT(0, 0),
                    MPFROM2SHORT(0, pBMPBody^.sCx-Cx) );
        WinSendMsg( hwndHScrol,
                    SBM_SETTHUMBSIZE,
                    MPFROM2SHORT(Cx,pBMPBody^.sCx),
                    MPFROM2SHORT(0, 0) );
        WinSendMsg( hwndHScrol,
                    SBM_SETPOS,
                    MPFROMSHORT((pBMPBody^.sCx-Cx) div 2+xEdge),
                    0);
    END;
END;

FUNCTION GraphScreenClass.CalcEdge:RectL;
VAR
    xDif,yDif:INTEGER;
    DrawRect:RectL;
BEGIN
    DrawRect:=GetDrawRect;
    xDif:=(Cx-DrawRect.xRight) div 2+xEdge;
    Inc(DrawRect.xRight,xDif);
    inc(DrawRect.xLeft,xDif);
    yDif:=(Cy-DrawRect.yTop) div 2+yEdge;
    Inc(DrawRect.yTop,yDif);
    Inc(DrawRect.yBottom,yDif);
    CalcEdge:=DrawRect;
END;

PROCEDURE GraphScreenClass.RedrawMsg;
BEGIN
    WinInvalidateRect(hwndPane,NIL,FALSE);
END;

FUNCTION GraphScreenClass.isArgEmpty:BOOLEAN;
BEGIN
    IF GetCount>0 THEN isArgEmpty:=FALSE ELSE isArgEmpty:=TRUE
END;

FUNCTION GraphScreenClass.GetStatusStr:string;
BEGIN
    GetStatusStr:='GSV:'+FileName+'   '+
                  IntToStr(NameIndex+1)+'/'+IntToStr(GetCount)+
                  ' scale('+IntToStr(Scale)+'%)'+
                  ' Timer:'+IntToStr(TimerAry[TimerIndex] div 1000)+'sec'+#0;
END;

PROCEDURE GraphScreenClass.DrawScreen(window:hwnd);
VAR
    ps :HPS;
    rect ,DrawRect,CurRect:RectL;
    yDif,xDif:INTEGER;
    rc:bool;
    st:string;
BEGIN
    WinQueryWindowRect(Window, rect);
    CurRect:=rect;
    ps:= WinBeginPaint(Window,0,@rect);
    IF isRGBColor THEN BEGIN
        GpiCreateLogColorTable(ps,
                               lCol_Reset,
                               lColF_RGB,
                               0,
                               0,
                               NIL);
    END;
    IF isArgEmpty=FALSE THEN BEGIN
        st:=GetStatusStr;
        WinSetWindowText(hwndFrame,@st[1]);
        DrawRect:=CalcEdge;
        DrawBitmap(DrawRect,ps);
    END
    ELSE BEGIN
        DrawRect.xLeft:=(CurRect.xRight-CurRect.xLeft) div 8;
        DrawRect.xRight:=DrawRect.xLeft*7;
        DrawRect.yBottom:=(CurRect.yTop-CurRect.yBottom) div 2 ;
        DrawRect.yTop:=DrawRect.yBottom+20;
        WinDrawText(ps,
                    -1,
                    'Drop Picture File or Foloder',
                    DrawRect,
                    CLR_RED,
                    CLR_WHITE,
                    DT_CENTER OR DT_VCenter OR DT_ERASERECT)
    END;
    CurRect:=rect;
    CurRect.yBottom:=DrawRect.yTop-1;
    rc:=WinFillRect(ps, CurRect, BkCol);

    CurRect:=rect;
    CurRect.yTop:=DrawRect.yBottom+1;
    rc:=WinFillRect(ps, CurRect, BkCol);

    CurRect:=rect;
    CurRect.xLeft:=DrawRect.xRight-1;
    rc:=WinFillRect(ps, CurRect, BkCOl);

    CurRect:=rect;
    CurRect.xRight:=DrawRect.xLeft+1;
    rc:=WinFillRect(ps, CurRect, BkCOl);
    WinEndPaint(ps);
END;


FUNCTION  LoadCalc(GsvCls:POINTER ):LONGINT;
VAR
    GSVClass:GraphScreenClass;
    rc:bool;
BEGIN
    GSVClass:=GraphScreenClass(GsvCls);
    GSVClass.LoadFile;
    rc:=WinPostMsg(hwndFrame,WM_EndThread,0,0);
END;

VAR
    ScaleLength:INTEGER;

FUNCTION SettingDlgProc( hwndDlg: HWND ;
                            ulMsg  : ULONG;
                            mp1    : MPARAM;
                            mp2    : MPARAM ) : mResult; cdecl;
VAR
    i:INTEGER;
    rc:UShort;
    st:string;
    hwndSlider:hwnd;
    ulRC:ULong;
BEGIN
    result:=0;
    CASE(ulMsg) OF
        WM_INITDLG:BEGIN
            WinSendDlgItemMsg(hwndDlg,
                             ID_RADIO1+GSVClass.TimerIndex-1,
                             BM_SETCHECK,
                             Ord(TRUE),0);
            hwndSlider:=WinWindowFromID(hwndDlg,ID_SLIDER);
            WinSendMsg(hwndSlider,
                       SLM_SETTICKSIZE,
                       MPFROM2SHORT(SMA_SETALLTICKS,7),
                       0);
            FOR i := 0 TO 11 DO BEGIN
                IF ((i mod 3)=2) OR (i=0) THEN BEGIN
                    St:=FloatToStr(i*0.2);
                    St := St+ #0;

                    WinSendMsg(hwndSlider,
                               SLM_SETSCALETEXT,
                               MPFROMSHORT(i),
                               MPFROMP(@St[1]));
                END;
            END;
            WinSendMsg(hwndSlider,
                       SLM_SETSLIDERINFO,
                       MPFROM2SHORT(SMA_SLIDERARMPOSITION,SMA_INCREMENTVALUE),
                       5);
            ulRC:=WinSendMsg(hwndSlider,
                            SLM_QUERYSLIDERINFO,
                            MPFROM2SHORT(SMA_SLIDERARMPOSITION,SMA_RANGEVALUE),
                            0);
            ulRC:=SHORT1FROMMP(ulRC);
            ScaleLength:=ulRC;
            ulRc:=TRUNC(ulRC*GSVClass.Ganmma);
            WinSendMsg(hwndSlider,
                       SLM_SETSLIDERINFO,
                       MPFROM2SHORT(SMA_SLIDERARMPOSITION,SMA_RANGEVALUE),
                       ulRC);

        END;
        WM_COMMAND:BEGIN
            CASE Short1FromMP( mp1) OF
                DID_OK:BEGIN
                    FOR i:=1 TO MaxTimer DO BEGIN
                        rc:=WinSendDlgItemMsg(hwndDlg,
                                              ID_RADIO1+i-1,
                                              BM_QUERYCHECK,
                                              0,0);
                        IF rc=Ord(TRUE) THEN BEGIN
                            GSVClass.TimerIndex:=i;
                        END;
                    END;
                    hwndSlider:=WinWindowFromID(hwndDlg,ID_SLIDER);
                    ulRC:=WinSendMsg(   hwndSlider,
                                        SLM_QUERYSLIDERINFO,
                                        MPFROM2SHORT( SMA_SLIDERARMPOSITION,
                                                      SMA_RANGEVALUE),
                                        0);
                    ulRC:=SHORT1FROMMP(ulRC);
                    GSVClass.Ganmma:=ulRC/ScaleLength;
                    WinDismissDlg(hwndDlg,Ord(TRUE));
                END;
                DID_CANCEL:
                    WinDismissDlg(hwndDlg,Ord(FALSE));
            END;
        END;(**WM_COMMNAD**)
        ELSE BEGIN
           result:=WinDefDlgProc(hwndDlg,ulMsg,mp1,mp2);
        END;
    END;(**case**)
END;

FUNCTION MainClientProc(Window: HWnd; Msg: ULong; Mp1,Mp2: MParam): MResult;
VAR
    i:INTEGER;
    St:String;
    aSWP:SWP;
    border:ULong;
    FrameFlag:ULong;
    OldGanmma:extended;
BEGIN
    result   :=0;
    CASE msg OF

        WM_TIMER:BEGIN
           WinStopTimer(GetAnchor,Window,MainTimerID);
           GSVClass.SetNext;
           GSVClass.ThreadID := VPBeginThread(LoadCalc,20480000,GSVClass);
        END;
        WM_ENDTHREAD:BEGIN
            DosKillThread(GSVClass.ThreadID);
            IF GSVClass.isFitWindow THEN
                GSVClass.CalcFitScale;
            GSVClass.RedrawMsg;
            IF (GSVClass.isArgEmpty=FALSE) AND GSVClass.isRun THEN
                WinStartTimer(GetAnchor,
                              Window,
                              MainTimerID,
                              TimerAry[GSVClass.TimerIndex]);
        END;
        WM_COMMAND:BEGIN
            CASE SHORT1FROMMP(mp1) OF
                IDB_LEFT:BEGIN
                    IF GSVClass.isArgEmpty THEN EXIT;
                    GSVClass.SetPrev;
                    GSVClass.LoadFile;
                    IF GSVClass.isFitWindow THEN
                        GSVClass.CalcFitScale;
                    GSVClass.RedrawMsg;
                END;
                IDB_RIGHT:BEGIN
                    IF GSVClass.isArgEmpty THEN EXIT;
                    GSVClass.SetNext;
                    GSVClass.LoadFile;
                    IF GSVClass.isFitWindow THEN
                        GSVClass.CalcFitScale;
                    GSVClass.RedrawMsg;
                END;
                IDB_STOP:BEGIN
                    IF GSVClass.isArgEmpty THEN EXIT;
                    GSVClass.isRun:=FALSE;
                    WinStopTimer(GetAnchor,Window,MainTimerID);
                END;
                IDB_RUN:BEGIN
                    IF GSVClass.isArgEmpty THEN EXIT;
                    GSVClass.isRun:=TRUE;
                    WinStartTimer(GetAnchor,
                                  Window,
                                  MainTimerID,
                                  TimerAry[GSVClass.TimerIndex]);
                END;
                IDB_FIT:BEGIN
                    IF GSVClass.isArgEmpty THEN EXIT;
                    GSVClass.isFitWindow:=TRUE;
                    GSVClass.CalcFitScale;
                    GSVClass.RedrawMsg;
                END;
                IDB_UP:BEGIN
                    IF GSVClass.isArgEmpty THEN
                        EXIT;
                    GSVClass.isFitWindow:=FALSE;
                    GSVClass.UpScale;
                    GSVClass.RedrawMsg;
                    st:=GSVClass.GetStatusStr;
                    WinSetWindowText(hwndFrame,@st[1]);
                END;
                IDB_DOWN:BEGIN
                    IF GSVClass.isArgEmpty THEN EXIT;
                    GSVClass.isFitWindow:=FALSE;
                    GSVClass.DownScale;
                    GSVClass.RedrawMsg;
                    st:=GSVClass.GetStatusStr;
                    WinSetWindowText(hwndFrame,@st[1]);
                END;
                IDB_UPTIME:BEGIN
                    i:=1;
                    WHILE (i<=GSVClass.TimerIndex) AND (i<MaxTimer) DO
                        Inc(i);
                    GSVClass.TimerIndex:=i;
                    st:=GSVClass.GetStatusStr;
                    WinSetWindowText(hwndFrame,@st[1]);

                END;
                IDB_DOWNTIME:BEGIN
                    i:=MaxTimer;
                    WHILE (i>1)  AND (GSVClass.TimerIndex<=i) DO BEGIN
                        Dec(i);
                    END;
                    GSVClass.TimerIndex:=i;
                    st:=GSVClass.GetStatusStr;
                    WinSetWindowText(hwndFrame,@st[1]);

                END;
                IDB_EXIT:BEGIN
                    SaveCfg;
                    WinPostMsg(Window, WM_QUIT, 0, 0);
                END;
                IDB_SETTING:BEGIN
                    OldGanmma:=GSVClass.Ganmma;
                    IF WinDlgBox(HWND_DESKTOP,
                                 Window,
                                 SettingDlgProc,
                                 NullHandle,
                                 ID_GSVSetting,
                                 NIL) =Ord(TRUE) THEN BEGIN
                        st:=GSVClass.GetStatusStr;
                        WinSetWindowText(hwndFrame,@st[1]);
                        GSVClass.MakeGanmmaPalette;
                        GSVClass.SetPngPalette;
                        IF OldGanmma<>GSVClass.Ganmma THEN BEGIN
                            IF GSVClass.FileCount>0 THEN
                                GSVClass.LoadFile;
                        END;
                        GSVClass.RedrawMsg;
                    END;
                END;
                IDB_FULLSCR:BEGIN
                    IF GSVClass.isFullScreen THEN BEGIN
                        WinSetParent(GSVClass.hwndTitle,hwndFrame,  FALSE );
                        WinSetParent(GSVClass.hwndSysMenu,hwndFrame,FALSE  );
                        WinSetParent(GSVClass.hwndMinMax,hwndFrame, FALSE);
                        WinSetParent(GSVClass.hwndVScrol,hwndFrame,FALSE);
                        WinSetParent(GSVClass.hwndHScrol,hwndFrame,FALSE);
                        GSVClass.isFullScreen:=FALSE;

                        WinSetWindowULong(hwndFrame,
                                          QWL_STYLE,
                                          GSVClass.OrgFrameFlag);
                        WinSendMsg( hwndFrame ,
                                    WM_UPDATEFRAME ,
                                    MPFROMLONG(GSVClass.OrgBorder) ,
                                    0 );
                        WinSetWindowPos(hwndFrame,NullHandle,
                                        GSVClass.OrgSWP.x,GSVClass.OrgSWP.y,
                                        GSVClass.OrgSWP.cx,GSVClass.OrgSWP.cy,
                                        SWP_ACTIVATE OR
                                        SWP_MOVE OR
                                        SWP_SIZE OR SWP_SHOW);
                    END
                    ELSE BEGIN
                        IF (MainTB.lType AND TB_FLOATING)=0 THEN BEGIN
                            SetToolbarState(hwndTB,TB_FLOATING);
                            WinDestroyWindow(hwndTB);
                            mainTB.lType:=TB_BUBBLE OR TB_FLOATING ;
                            hwndTB:=CreateToolbar(hwndFrame,mainTB);
                        END;
                        WinQueryWindowPos(hwndFrame,GSVClass.OrgSWP);
                        WinQueryWindowPos(hwnd_DESKTOP,aSWP);
                        WinSetWindowPos(hwndFrame,NullHandle,
                                        aSWP.x, aSWP.y,
                                        aSWP.cx,aSWP.cy,
                                        SWP_ACTIVATE OR
                                        SWP_MOVE OR
                                        SWP_SIZE OR SWP_SHOW);
                        WinSetParent(GSVClass.hwndMinMax, HWND_OBJECT,FALSE);
                        WinSetParent(GSVClass.hwndTitle,  HWND_OBJECT,FALSE);
                        WinSetParent(GSVClass.hwndSysMenu,HWND_OBJECT,FALSE);
                        WinSetParent(GSVClass.hwndVScrol, HWND_OBJECT,FALSE);
                        WinSetParent(GSVClass.hwndHScrol, HWND_OBJECT,FALSE);
                        FrameFlag:=WinQueryWindowULong(hwndFrame,QWL_STYLE );
                        GSVClass.OrgFrameFlag:=FrameFlag;

                        border:= FrameFlag
                                    AND (FS_BORDER OR
                                         FS_DLGBORDER OR
                                         FS_SIZEBORDER);
                        GSVClass.OrgBorder:=border;
                        WinSetWindowULong(hwndFrame,
                                          QWL_STYLE,
                                          FrameFlag-border);
                        WinSendMsg( hwndFrame ,
                                    WM_UPDATEFRAME ,
                                    MPFROMLONG(border) ,
                                    0 );

                        GSVClass.isFullScreen:=TRUE;
                        WinSendMsg( hwndFrame ,
                                    WM_UPDATEFRAME ,
                                    MPFROMLONG(border) ,
                                    0 );
                    END;
                END;
            END;
        END;
        WM_CLOSE:BEGIN
            SaveCfg;
            WinPostMsg(Window, WM_QUIT, 0, 0);
        END;
        ELSE BEGIN
            result:=WinDefWindowProc(Window, msg, mp1, mp2);
        END;
    END;
END;


FUNCTION PaneClientProc(Window: HWnd; Msg: ULong; Mp1,Mp2: MParam): MResult;
VAR
    xScroll,yScroll:INTEGER;
BEGIN
    result   :=0;
    CASE msg OF
        wm_vscroll:BEGIN
            IF (GSVClass.pBMPBody^.sCy-GSVCLass.Cy) <=0 THEN
                EXIT;
            CASE SHORT2FROMMP(mp2) OF
                SB_LINEUP:BEGIN
                    Dec(GSVClass.yEdge,5);
                    yScroll:=(GSVClass.pBMPBody^.sCy-GSVCLass.Cy) div 2
                            + GSVClass.yEdge;
                END;
                SB_LINEDOWN:BEGIN
                    Inc(GSVClass.yEdge,5);
                    yScroll:=(GSVClass.pBMPBody^.sCy-GSVCLass.Cy) div 2
                            + GSVClass.yEdge;
                END;
                SB_PAGEUP:BEGIN
                    Dec(GSVClass.yEdge,GSVClass.Cy);
                    yScroll:=(GSVClass.pBMPBody^.sCy-GSVCLass.Cy) div 2
                            + GSVClass.yEdge;

                END;
                SB_PAGEDOWN:BEGIN
                    inc(GSVClass.yEdge,GSVClass.Cy);
                    yScroll:=(GSVClass.pBMPBody^.sCy-GSVCLass.Cy) div 2
                            + GSVClass.yEdge;
                END;
                SB_SLIDERTRACK,SB_SLIDERPOSITION:BEGIN
                    yScroll:=SHORT1FROMMP(mp2);
                    GSVClass.yEdge:=yScroll-
                                    (GSVClass.pBMPBody^.sCy-GSVCLass.Cy) div 2;
                END;
            END;
            IF yScroll<0 THEN BEGIN
                yScroll:=0;
                GSVClass.yEdge:=-(GSVClass.pBMPBody^.sCy-GSVCLass.Cy) div 2;
            END;
            IF yScroll>GSVClass.pBMPBody^.sCy-GSVClass.Cy THEN BEGIN
                yScroll:=(GSVClass.pBMPBody^.sCy-GSVCLass.Cy);
                GSVClass.yEdge:=(GSVClass.pBMPBody^.sCy-GSVCLass.Cy) div 2;
            END;

            WinSendMsg( GSVClass.HwndVScrol,
                        SBM_SETPOS,
                        MPFROMSHORT(yScroll),
                        0);
            GSVClass.RedrawMsg;
        END;
        wm_hscroll:BEGIN
            IF (GSVClass.pBMPBody^.sCx-GSVCLass.Cx) <0 THEN
                EXIT;
            CASE SHORT2FROMMP(mp2) OF
                SB_LINELEFT:BEGIN
                    Dec(GSVClass.xEdge,5);
                END;
                SB_LINERIGHT:BEGIN
                    Inc(GSVClass.xEdge,5);
                END;
                SB_PAGELEFT:BEGIN
                    Dec(GSVClass.xEdge,GSVClass.Cx);
                END;
                SB_PAGERIGHT:BEGIN
                    Inc(GSVClass.xEdge,GSVClass.Cx);
                END;
                SB_SLIDERTRACK,SB_SLIDERPOSITION:BEGIN
                    xScroll:=SHORT1FROMMP(mp2);
                    GSVClass.xEdge:=xScroll-
                                    (GSVClass.pBMPBody^.sCx-GSVCLass.Cx) div 2;
                END;
            END;
            xScroll:=(GSVClass.pBMPBody^.sCx-GSVCLass.Cx) div 2 + GSVClass.xEdge;
            IF xScroll<0 THEN BEGIN
                xScroll:=0;
                GSVClass.xEdge:=-(GSVClass.pBMPBody^.sCx-GSVCLass.Cx) div 2;
            END;
            IF xScroll>GSVClass.pBMPBody^.sCx-GSVClass.Cx THEN BEGIN
                xScroll:=(GSVClass.pBMPBody^.sCx-GSVCLass.Cx);
                GSVClass.xEdge:=(GSVClass.pBMPBody^.sCx-GSVCLass.Cx) div 2;
            END;

            WinSendMsg( GSVClass.HwndHScrol,
                        SBM_SETPOS,
                        MPFROMSHORT(xScroll),
                        0);
            GSVClass.RedrawMsg;
        END;
        ELSE
            result:=WinDefWindowProc(Window, msg, mp1, mp2);

    END;
END;


FUNCTION DropToString(mp1,mp2:MParam):string;
VAR
    pChFile,achFile,achPath : ARRAY[0..CCHMAXPATH-1] OF CHAR;
    pdiDrag : PDRAGINFO;
    pdiItem : PDRAGITEM;
BEGIN
    pdiDrag := PVOIDFROMMP(mp1);
    DrgAccessDraginfo( pdiDrag^ );

    pdiItem := DrgQueryDragitemPtr(pdiDrag^, 0);
    DrgQueryStrName(pdiItem^.hstrContainerName,sizeof(achPath),achPath);
    DosQueryPathInfo(achPath,FIL_QUERYFULLNAME,achPath,sizeof(achPath));

    IF (achPath[strlen(achPath)-1] <> '\') THEN strcat(achPath, '\');
    DrgQueryStrName(pdiItem^.hstrSourceName,sizeof(achFile),achFile);
    strcopy( pchFile, achPath );
    strcat( pchFile, achFile );
    result:=StrPas(PchFile);
    WinSendMsg( pdiDrag^.hwndSource,
            DM_ENDCONVERSATION,
            MPFROMLONG(pdiItem^.ulItemID),
            MPFROMLONG(DMFL_TARGETSUCCESSFUL) );

    DrgFreeDraginfo(pdiDrag^);
END;

FUNCTION DrawPaneClientProc(Window:HWnd;Msg:ULong;Mp1,Mp2:MParam):MResult;
VAR
    i:INTEGER;
    st:string;
    AttrFound:ULong;
    ps:hps;
    ColTable:ARRAY[0..15]OF ULong;
BEGIN
    result:=0;
    CASE msg OF
        WM_CREATE:BEGIN
            IF GSVClass.isArgEmpty=FALSE THEN BEGIN
                GSVClass.SetFirst;
                GSVClass.LoadFile;
                IF GSVClass.isFitWindow THEN BEGIN
                    GSVClass.CalcFitScale;
                END;
            END;
            GSVClass.CreateScroll(window);
            GSVClass.DrawScreen(window);
        END;
        WM_PAINT:BEGIN
            GSVClass.DrawScreen(window);
            GSVClass.SetScroll;
        END;
        WM_SIZE:BEGIN
            GSVClass.SetPaneSize(SHORT1FROMMP(mp2),SHORT2FROMMP(mp2));
            IF GSVClass.isArgEmpty=FALSE THEN BEGIN
                IF GSVClass.isFitWindow THEN BEGIN
                    GSVClass.CalcFitScale;
                END;
                GSVClass.SetScroll;
            END;
        END;
        DM_DRAGOVER:BEGIN
            result:=MRFROM2SHORT(DOR_DROP, DO_MOVE);
        END;
        DM_DROP:BEGIN
            WinStopTimer(GetAnchor,Window,MainTimerID);
            DosKillThread(GSVClass.ThreadID);
            IF GSVClass.isArgEmpty=FALSE THEN BEGIN
                GSVClass.FlushList;
            END;
            St:=DropToString(mp1,mp2);

            GSVClass.EvalArg(St);
            IF GSVClass.isArgEmpty=FALSE THEN BEGIN
                GSVClass.xEdge:=0;
                GSVClass.yEdge:=0;
                GSVClass.SetFirst;
                GSVClass.LoadFile;
                IF GSVClass.isFitWindow THEN BEGIN
                        GSVClass.CalcFitScale;
                END;
                GSVClass.SetScroll;
            END;
            GSVClass.RedrawMsg;
        END;
        WM_PRESPARAMCHANGED:BEGIN
            IF mp1=PP_BackGroundColor THEN BEGIN
                WinQueryPresParam(Window,
                                  PP_BackGroundColor,
                                  0,
                                  @AttrFound,
                                  SizeOf(ULong),
                                  @BkCol,
                                  qpf_NoInherit);
                GSVClass.isRGBColor:=TRUE;

            END;
            GSVClass.RedrawMsg;
        END;
        ELSE
            result:=WinDefWindowProc(Window, msg, mp1, mp2);
    END;
END;

VAR
    mq       :HMQ;
    msg      :QMSG;
    swp      :os2pmapi.SWP;
    St:string;
    Anchor:HAB;

BEGIN
// HALT;
    Anchor:=WinInitialize(0);
    IF Anchor=0 THEN HALT(-1);

    mq:=WinCreateMsgQueue(Anchor, 0);

    IF mq=0 THEN BEGIN
        WinTerminate(Anchor);
        HALT(-2);
    END;

    ToolkitInit(Anchor);

    WinRegisterClass(Anchor,
                     'BitmapPane',
                     DrawPaneClientProc,
                     CS_SIZEREDRAW,
                     sizeof(ULONG));

    WinQueryWindowPos(HWND_DESKTOP, swp);

    GSVClass:=GraphScreenClass.Create;
    LoadCfg;
    GetOpt:=GetOptClass.Create('rpcgs','');
    isSort:=FALSE;
    isSubDir:=FALSE;
    WHILE GetOpt.isOptEnd=FALSE DO BEGIN
        CASE GetOpt.GetOptCh OF
            'r':BEGIN
                isSubDir:=TRUE;
            END;
            'p':BEGIN
                isRun:=TRUE;
            END;
            'c':BEGIN
                IF GetOpt.isEnd=FALSE THEN BEGIN
                    isRGBColor:=TRUE;
                    St:=GetOpt.GetNextArg;
                    TRY
                        BkCol:=StrToInt(St);
                    EXCEPT
                        BkCol:=CLR_WHITE;
                        isRGBColor:=FALSE;
                    END;
                END;
            END;
            'g':BEGIN
                IF GetOpt.isEnd=FALSE THEN BEGIN
                    St:=GetOpt.GetNextArg;
                    TRY
                        GSVClass.Ganmma:=StrToFloat(st);
                    EXCEPT
                        GSVClass.Ganmma:=1;
                    END;
                    GSVClass.MakeGanmmaPalette;
                    GSVClass.SetPngPalette;
                END;
            END;
            's':BEGIN
                isSort:=TRUE;
            END;
        END;
    END;
    GSVClass.isSubDir:=isSubDir;
    GSVClass.isSort:=isSort;
    GSVClass.isRun:=isRun;
    GSVClass.isRGBColor:=isRGBColor;
    WHILE GetOpt.isEnd=FALSE DO BEGIN
        GSVClass.EvalArg(GetOpt.GetNextArg);
    END;

    hwndFrame:=CreateCell(mainClient, HWND_DESKTOP, 0);
    IF hwndFrame<>0 THEN BEGIN
        WinSetWindowPos(hwndFrame,
                        NULLHANDLE,
                        swp.x + swp.cx div 8,
                        swp.y + swp.cy div 8,
                        (swp.cx div 4) * 3,
                        (swp.cy div 4) * 3,
                        SWP_ACTIVATE OR SWP_MOVE OR SWP_SIZE OR SWP_SHOW);

        hwndTB:=CreateToolbar(hwndFrame,mainTb);

        GSVClass.hwndPane:=CellWindowFromID(hwndFrame, ID_DRAWPANE);
        GSVClass.hwndTitle:=WinWindowFromID(hwndFrame,FID_TITLEBAR);
        GSVClass.hwndSysMenu:=WinWindowFromID(hwndFrame,FID_SYSMENU);
        GSVClass.hwndMinMax:=WinWindowFromID(hwndFrame,FID_MINMAX);

        IF GSVClass.isRun THEN
            WinSendMsg(WinWindowFromID(hwndFrame,FID_CLIENT),
                       WM_COMMAND,
                       IDB_RUN,
                       0);
            WinSetWindowPos(hwndFrame,
                            NULLHANDLE,
                            xPos,yPos,xWidth,yHeight,
                            SWP_ACTIVATE OR SWP_MOVE OR SWP_SIZE OR SWP_SHOW);

        // -------------------------------
        WHILE WinGetMsg(Anchor,msg,0,0,0) DO WinDispatchMsg(Anchor,msg);
        // -------------------------------
        WinDestroyWindow(hwndFrame);
    END;

    WinDestroyMsgQueue(mq);
    WinTerminate(Anchor);
END.




{
$Log: GSV.PAS $
Revision 1.83  2007/06/02 22:34:21  Average
PNGɂpbg

Revision 1.82  2007/06/02 21:49:17  Average
K}l̐ݒMă_CAOƏCB

Revision 1.81  2007/04/17 13:45:08  Average
SetScrollœK

Revision 1.80  2007/04/14 16:16:26  Average
ŃXN[͍ĂƎv

Revision 1.79  2007/04/11 15:16:57  Average
XN[C(?)

Revision 1.78  2007/04/11 15:00:18  Average
XN[̂C

Revision 1.77  2007/03/24 14:27:29  Average
\[gĂ݂܂B

Revision 1.76  2007/02/25 16:16:43  Average
y[Wւ̃V[gJbg쐬

Revision 1.75  2006/12/16 15:29:36  Average
K}ϊ̃_CAO

Revision 1.74  2006/12/09 16:28:36  Average
XC_[

Revision 1.73  2006/12/09 15:06:54  Average
Ƃ肠ݒ_CAO玞ԊԊu悤

Revision 1.72  2006/12/09 14:41:43  Average
_CAÕfUCύX

Revision 1.70  2006/12/09 09:19:08  Average
*** empty log message ***

Revision 1.69  2006/12/09 06:13:19  Average
*** empty log message ***

Revision 1.68  2006/12/04 12:39:20  Average
IvV̐܂ςăRgXg𔲂

Revision 1.67  2006/12/04 12:37:03  Average
IvV̌`ςāAK}l̐lw\

Revision 1.65  2006/11/30 15:26:31  Average
XN[̃oOC

Revision 1.64  2006/11/15 12:13:42  Average
[g̉摜sȂ悤

Revision 1.63  2006/11/15 11:52:33  Average
XN[oȂƂ鎖C

Revision 1.62  2006/11/15 11:42:17  Average
IvVcfgɏނ̂ċAAXChV[͏O

Revision 1.61  2006/11/15 11:40:24  Average
XN[̕ψڗʂ̃oOC

Revision 1.60  2006/11/14 15:08:16  Average
XN[|WV̏C

Revision 1.59  2006/11/14 15:02:55  Average
tBbg̃ItZbg

Revision 1.58  2006/11/14 14:08:06  Average
Ƃ肠`FbNCĂ
B

Revision 1.57  2006/11/13 15:09:49  Average
N̈ʒuƏꏊoĂ悤

Revision 1.56  2006/11/13 14:55:49  Average
ԊԊȕC

Revision 1.55  2006/11/10 16:26:29  Average
RtBOt@C̎

Revision 1.54  2006/11/10 16:02:23  Average
摜]̓hCBJ[IvṼG[̑Ώ

Revision 1.53  2006/11/10 15:50:57  Average
R}hCIvVA-r,-p,-c̓

Revision 1.52  2006/11/09 15:23:05  Average
tXN[[h

Revision 1.51  2006/11/09 13:34:44  Average
pbgɂwiFɑΉ

Revision 1.50  2006/11/09 12:27:54  Average
\啪ς
@\͑OƕςȂEEE

Revision 1.26  2006/11/09 12:19:31  Average
hbvɃt@CȂ̃G[C

Revision 1.25  2006/11/08 11:12:16  Average
^C}[ԊuԈႦĂ܂

Revision 1.24  2006/11/07 15:34:48  Average
hbv̖_C

Revision 1.23  2006/11/05 13:23:42  Average
 t@CP̂̎̃G[C

Revision 1.22  2006/11/04 17:21:32  Average
ANZ[^

Revision 1.21  2006/11/04 16:50:42  Average
XN[삷悤

Revision 1.20  2006/11/04 16:32:42  Average
c悤

Revision 1.19  2006/11/04 16:24:01  Average
Ƃ肠XN[̖͓悤

Revision 1.18  2006/11/04 15:40:37  Average
XC_[̃tbN쐬

Revision 1.17  2006/11/04 14:31:07  Average
XN[̈ʒuӎ悤

Revision 1.16  2006/11/04 14:22:45  Average
`ƕς

Revision 1.15  2006/11/04 14:21:17  Average
ƏC

}
